/*------------------------------------------------------------------------
  Neuricam SpA   - Trento - Italy
  http://www.neuricam.com
  email:  techsupport@neuricam.com , info@neuricam.com
--------------------------------------------------------------------------
  Filename: default_parms.h
--------------------------------------------------------------------------
  Project:       <PCN-1001>
  Author(s):     <Roberto Doriguzzi> <Roberto Corradi>
  First release: <Jan 2007>
  Description:   <PCN-1001 image server, defines>
-------------------------------------------------------------------------*/

#define VERSION	"1.0.0"		// AVL - Light data_collection

#define SYSTEM  "PCN-1001"	// system name

#define MAX_ZONE 255
#define MAX_SYSTEM 255
#define MAX_SYSTEM_IN_ZONE 255

//#define MAX_CONN 256			// max connections
//#define MAX_STR_LENGTH 		256

#define PARM_STR_LEN		32

//#define REC_LINE_LEN		34	// records lines length
//#define MAX_REC_LINES		100000	// max number of lines for each file
//#define MAX_REC_FILES		10	// max number of differrent records files
//#define RECORD_INTERVAL		60 	// 60 seconds
#define WD_INTERVAL		10	// 10 seconds
//#define MAX_PEOPLE_PER_SEC	10  	// if people run at 5m/sec and the detection area 
					// is 100*120, i.e. 2 lanes

//#define MAX_RECORDS		MAX_PEOPLE_PER_SEC*RECORD_INTERVAL


#define MAX_DATA_LEN		4096		
#define MAX_PACKET_LEN		5+1+1+1+1+1+2+MAX_DATA_LEN+2+1
#define MAX_CRC_DIGITS       	256
#define BYTE_WIDTH            	8
#define CRC_WIDTH             	16
#define CRC_MASK              	0xFF

#define MAP_SIZE 0xffff			// gpios map size
#define MAP_MASK 0xffff		// gpios map mask

#define WORK_DIR	"/var/user/"
#define PM_FILENAME 	"parameters.txt"
#define CT_FILENAME 	"PCN1001.txt"
#define TP_FILENAME 	"sys_topology.txt"
//#define OS_FILENAME 	"/etc/system.info"
//#define KL_FILENAME 	"/proc/version"
#define SERIAL_DEV3 	"/dev/ttyZ3"
//#define MESSAGE_L	5		// length of a message coming from RS485 port

#define RISING		1
#define FALLING		2
#define RISING_FALLING	3

#define PCIOCSOUT	_IO('v',50)
#define PCIOCGINT	_IOR('v',51, unsigned short)
#define PCIOCSINT	_IOW('v',52, unsigned short)
#define PCIOCGIN	_IOR('v',53, unsigned char)
#define PCIOCSIN	_IOW('v',54, unsigned char)

#define MAINLOOP_STOP	0
#define MAINLOOP_START	1

//#define PORT 		5400	// socket port
//#define UDP_PORT	5402	// RTP port

/*******************  default parameters *************************/

#define SERIAL_BR	B115200	// 115200 bits per second (ttyZ3)
#define SERIAL_DB	CS8	// 8 bits (ttyZ3)
#define SERIAL_PR	0	// no parity (ttyZ3)
#define SERIAL_SB	0	// 1 stop bit (ttyZ3)
#define SERIAL_ID  	0x01	// serial ID
#define TIMER_DATA	3	// timer ask data to systems

