/*------------------------------------------------------------------------
  Neuricam SpA   - Trento - Italy
  http://www.neuricam.com
  email:  techsupport@neuricam.com , info@neuricam.com
--------------------------------------------------------------------------
  Filename: loops.cpp
--------------------------------------------------------------------------
  Project:       <People counter>
  Author(s):     <Roberto Doriguzzi><Roberto Corradi>
  First release: <Jun 2005>
  Description:   <People counter image server, thread loops>
-------------------------------------------------------------------------*/
/******************************************************************/
/**********  standalone mode loop  ********************************/
/******************************************************************/
void *main_loop(void *)
{
  FILE *counterct_zone;
  time_t curtime;
  struct tm *loctime;


  while(thread_status != MAINLOOP_STOP)
  {
    sleep(get_parms("timer_data"));
    thread_sleep = false;

//*************************************** Aggiorno stato di tutte le porte ***************************
    for(int i=0;i<255;i++)  
    {
      for(int u=0;u<255;u++)
      {
        if(sys_topology[i][u]!=0)
        {  
           #ifdef DEBUG
           printf("Send gdoorstatus to ID %d \n",sys_topology[i][u]);
           #endif
           SNP_Send(sys_topology[i][u],"gdoorstatus",NULL,0,ttyZ3);
           answer_msg=false;
           tmout=200;  
           while (--tmout && answer_msg==false)
             usleep(1);  // va bene forse 1
        //   #ifdef DEBUG
           if(!tmout)  
               printf("Time out error. System %d don't respond message gdoorstatus !\n",sys_topology[i][u]);	  
        //   #endif     
        }
      }
    }  

//*************************************** Aggiorno contatori per tutte le porte aperte***************************
    for(int i=0;i<255;i++)
    {
      for(int u=0;u<255;u++)
      {
        if((sys_topology[i][u]!=0)&&(door_status[sys_topology[i][u]]==1))
        {  
           #ifdef DEBUG
           printf("Send gcounters to ID %d \n",sys_topology[i][u]);
           #endif
           SNP_Send(sys_topology[i][u],"gcounters",NULL,0,ttyZ3);
           answer_msg=false;
           tmout=200;  
           while (--tmout && answer_msg==false)
             usleep(1);  // va bene forse 1
        //   #ifdef DEBUG
           if(!tmout)
               printf("Time out error. System %d don't respond message gcounters !\n",sys_topology[i][u]);	  
        //   #endif     
        }
      }
    }

//**************************************************************************************************************

    curtime = time (NULL);
    loctime = localtime (&curtime);

    for(int i=0;i<255;i++)
    {
      old_people_in_zone[i][0]=people_in_zone[i][0];
      old_people_in_zone[i][1]=people_in_zone[i][1];      
      people_in_zone[i][0]=0;
      people_in_zone[i][1]=0;
      door_status_in_zone_open[i]=0;
      old_door_status_in_zone_open[i]=0;
      door_status_in_zone_close[i]=1;
      old_door_status_in_zone_close[i]=1;
      for(int u=0;u<255;u++)
      {
        if(sys_topology[i][u]!=0)
        {
          people_in_zone[i][0]+=people[sys_topology[i][u]][0];
          people_in_zone[i][1]+=people[sys_topology[i][u]][1];
          door_status_in_zone_open[i] |= door_status[sys_topology[i][u]];
          old_door_status_in_zone_open[i] |= old_door_status[sys_topology[i][u]];
          door_status_in_zone_close[i] &= !door_status[sys_topology[i][u]];
          old_door_status_in_zone_close[i] &= !old_door_status[sys_topology[i][u]];
        }
      }


      if((people_in_zone[i][0] != old_people_in_zone[i][0])||(people_in_zone[i][1] != old_people_in_zone[i][1]))
      {
        for(int u=0;u<255;u++)
        {
           if(sys_topology[i][u]!=0)
             {
               sprintf(records[i],"Sys.ID %d: %02d/%02d/%04d %02d:%02d:%02d %06ld %06ld\n",
                	sys_topology[i][u],
          		loctime->tm_mday,loctime->tm_mon+1,1900+loctime->tm_year,
	  		loctime->tm_hour,loctime->tm_min,loctime->tm_sec,
			people[sys_topology[i][u]][0],people[sys_topology[i][u]][1]);  
               if((counterct_zone = fopen(log_filename_zone[i],"a+")))
               {
                 fprintf(counterct_zone,"%s",records[i]);
                 fclose(counterct_zone); 
               }
               else 
                 printf("Error open: %s",log_filename_zone[i]);
              #ifdef DEBUG
              printf("%s\n",records[i]);
              #endif
             }
        }   
      }
     
   
      if((door_status_in_zone_open[i]==1)&&(old_door_status_in_zone_open[i]==0))
      {        
        if(i==2 | i==3 | i==4 | i==5) old_door_status[i]=door_status[i];
        sprintf(records[i],"Zone %d: Start %02d/%02d/%04d %02d:%02d:%02d %06ld %06ld\n",
                i,
          	loctime->tm_mday,loctime->tm_mon+1,1900+loctime->tm_year,
	  	loctime->tm_hour,loctime->tm_min,loctime->tm_sec,people_in_zone[i][0],people_in_zone[i][1]);
        if((counterct_zone = fopen(ct_filename_zone[i],"a+")))
           {
           fprintf(counterct_zone,"%s",records[i]);
           fclose(counterct_zone); 
           #ifdef DEBUG
           printf("%s\n",records[i]);
           #endif
           }
        else 
           printf("Error open: %s",ct_filename_zone[i]);
      }
      if((door_status_in_zone_close[i]==1)&&(old_door_status_in_zone_close[i]==0))
      {
        if(i==2 | i==3 | i==4 | i==5) old_door_status[i]=door_status[i];
        sprintf(records[i],"Zone %d: Stop  %02d/%02d/%04d %02d:%02d:%02d %06ld %06ld\n",
                i,
          	loctime->tm_mday,loctime->tm_mon+1,1900+loctime->tm_year,
	  	loctime->tm_hour,loctime->tm_min,loctime->tm_sec,people_in_zone[i][0],people_in_zone[i][1]);
        if((counterct_zone = fopen(ct_filename_zone[i],"a+")))
           {
           fprintf(counterct_zone,"%s",records[i]);
           fclose(counterct_zone);
           #ifdef DEBUG
           printf("%s\n",records[i]);
           #endif  
           }
        else 
           printf("Error open: %s",ct_filename_zone[i]);
      }
    }
  #ifdef DEBUG
  printf("\n");
  #endif
  wd_check = 1;		// the main loop loop is alive
  thread_sleep = true;
  }


  #ifdef DEBUG
  printf("main loop end");
  #endif
  thread_status = MAINLOOP_STOP;
  return (void *) thread_status;
}


/******************************************************************/
/************** serial port loops  *********************************/
/******************************************************************/
//---------------input port serial--------------------------------//
void *ser_loopttyZ3(void *arg)
{
  int datalen;
  unsigned int args_size;
  char *command,*args;
  unsigned char sender,recipient;
  static char buf[MAX_PACKET_LEN];

  while(ttyZ3 > 0)
  {  
    start_loop_ttyZ3:
    memset(buf,0,MAX_PACKET_LEN);
    if((datalen = SNP_Recv(buf,&sender,&recipient,ttyZ3)) < 0) goto start_loop_ttyZ3;
    
    if(datalen >= 0)
    {
      command = (char *)&buf[8];
      args = (char *)&buf[8+(strlen((char *)&buf[8])+1)];
      args_size = datalen-(strlen((char *)&buf[8])+1);
   
      SNP_reply(sender,recipient,command,args,args_size,ttyZ3);
    }
  }
  return NULL;
}

/******************************************************************/
/*	enabling/disabling the mainloop thread			  */
/******************************************************************/
void mainloop_enable(bool enable)
{
  if(enable)
  {
    if(thread_status < MAINLOOP_START) //starting the acquisition thread
    {
      thread_status = MAINLOOP_START;
      pthread_create (&mloop, NULL, main_loop, NULL);
    }
  }
  else
  {
    thread_status = MAINLOOP_STOP;  		//stopping the acquisition thread
    pthread_join(mloop,NULL);			//waiting until the thread terminates
    pthread_cancel(mloop);
  }
}
/*****************************************************************/
/************* watchdog loop *************************************/
/*****************************************************************/
void *watchdog_loop(void *arg)
{
  while(watchdog > 0)
  {
    sleep(WD_INTERVAL);
    if(thread_status == MAINLOOP_START)
    {
      if(wd_check) // checking if the mainloop is alive
      {
        ioctl(watchdog, WDIOC_KEEPALIVE, 0);
        wd_check = 0;
      }
    }
    else ioctl(watchdog, WDIOC_KEEPALIVE, 0);
  }
  return NULL;
}
/*****************************************************************/
/************  optocoupled in loop ******************************/
/*****************************************************************/
void *input_loop(void *arg)
{
unsigned char tmp;
bool error;
bool sys_in_topology;
 
  while(1)
  {
  if(thread_sleep==true)
    { 
     usleep(4);
     int tmp_stauts_opto = read_opto();
     if((tmp_stauts_opto & 0x0f) != (stauts_opto & 0x0f))
       {
     //  printf("stauts_opto: %d   tmp_stauts_opto: %d \n",stauts_opto & 0x0f,tmp_stauts_opto & 0x0f);
       tmp = tmp_stauts_opto ^ stauts_opto;
       error=false;
       sys_in_topology=false;
       for(int i=0;i<4;i++) 
         {

         for(int h=0;h<255;h++)
            for(int u=0;u<255;u++)
               if(sys_topology[h][u]==(i+2))
                  sys_in_topology=true;  // va spedito solo se sistema (2,3,4 o 5) è nei sistemi installati

         if((tmp >> i & 0x01) == 0x01 &  sys_in_topology==true)
           {
           tmout=200;  
           while (--tmout && answer_msg==false)
             usleep(1);  // va bene forse 1
           #ifdef DEBUG
           if(!tmout)
             printf("Time out error. System don't respond \n");	  
           #endif  

           unsigned char val = ((tmp_stauts_opto >> i) & 0x01);
           #ifdef DEBUG
           printf("Send enable_pc %d to ID %d \n",val,i+2);
           #endif       
           SNP_Send(i+2,"enable_pc",(char*)&val,sizeof(unsigned char),ttyZ3);
           answer_msg=false;
           tmout=200;  
           while (--tmout && answer_msg==false)
           usleep(1);  
        //   #ifdef DEBUG
           if(!tmout)  
              printf("Time out error. System %d don't respond message enable_pc %d !\n",i+2,val);	  
        //   #endif   
           if(!tmout)
              error=true; 
           sys_in_topology=false;
           }
         if(!error) 
            stauts_opto=tmp_stauts_opto;
         } 
       }
     }
   }
}


/***************************************************************************/
/************************** read optcoupled ********************************/
/***************************************************************************/
int read_opto()
{    
  unsigned char val1,val2,val3,val4;    

  if (opto1 > 0) 
  {
    lseek(opto1,0,SEEK_SET);
    read(opto1,&val1,sizeof(val1));
    val1 &= 0x01;
  } 

  if (opto2 > 0) 
  {
    lseek(opto2,0,SEEK_SET);
    read(opto2,&val2,sizeof(val2));
    val2 &= 0x01;
    val2= val2 << 1;
  }

  if (opto3 > 0) 
  {
    lseek(opto3,0,SEEK_SET);
    read(opto3,&val3,sizeof(val3));
    val3 &= 0x01;
    val3= val3 << 2;
  }

  if (opto4 > 0) 
  {
    lseek(opto4,0,SEEK_SET);
    read(opto4,&val4,sizeof(val4));
    val4 &= 0x01;
    val4= val4 << 3;
  }

return (val1 & 0x01)|(val2 & 0x02)|(val3 & 0x04)|(val4 & 0x08);
}



